Anonymous Login
2017-04-23 13:50 CEST

View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0001903OpenClonkEngine - C4Scriptpublic2017-04-12 11:27
ReporterMarky 
Assigned ToIsilkor 
PrioritynormalSeveritymajorReproducibilityhave not tried
StatusresolvedResolutionno change required 
Product Version 
Target VersionFixed in Version 
Summary0001903: Inconclusive error message "ERROR: internal error: value stack left unbalanced (in Definition.FunctionName)"
DescriptionIn some of my custom scenarios the above mentioned message appears, and it does not really tell me how to fix the error.

It seems to be related to old style effect calls, such as "FxInt...Timer"; Replacing these with a new style effect definition seems to fix the problem, as the error message no longer appears.

Unfortunately, the parser does not tell me about all occurrences in the log: I have to fix one problem at a time, so after fixing one problem I get the next message. This makes getting the objects to a compatible state tiresome.
TagsNo tags attached.
Attached Files

-Relationships
+Relationships

-Notes

~0005645

Marky (developer)

Found the problem: this message occurs if you overload a function call and the parameters are inconsistent between the original and the overloaded function.

~0005646

Isilkor (developer)

Last edited: 2017-04-10 19:25

View 2 revisions

Can you attach a test case for this bug?

> In some of my custom scenarios the above mentioned message appears, and it does not really tell me how to fix the error.
Internal errors happen when the engine made some assumptions about its current state, but finds out that the state is not what it expected. It means the parser got confused at some point; you should not work around it in script, we need to fix it in C++.

~0005647

Marky (developer)

Yes, it's a crash in C++. Still, the issues can be fixed by fixing issues in the script, so whatever causes the crash at the moment should ideally give you a warning with a line number later.

I added comments in the script what the actual errors are, because it is not so obvious what is wrong in either file, just by looking at the script.

~0005649

Marky (developer)

Don't know if you got the message, the test case is attached in the bug entry :)

~0005650

Isilkor (developer)

I'm getting "C4AulScriptEngine linked - 83098 lines, 15 warnings, 0 errors" with that scenario on the 06a1ebe autobuild, and apparently so does @Clonkonaut.

~0005651

Marky (developer)

I was using an older snapshot, so I guess it's fixed then. Should we add the test to the repository nonetheless? I can upload my log, too, if it helps.

~0005652

Isilkor (developer)

Which snapshot was that? I don't believe there has been any changes to the parser recently, so it might have been something on the script side. If so, we can (and should) still fix the parser.

~0005653

Marky (developer)

Here is the log file

~0005654

Isilkor (developer)

The crash you're seeing is from passing an invalid parameter to a CRT function which we fixed a month ago. The internal error message is ultimately harmless and doesn't occur in current builds, so I'm going to tentatively mark this one invalid.
+Notes

-Issue History
Date Modified Username Field Change
2017-04-09 23:16 Marky New Issue
2017-04-10 07:11 Marky Note Added: 0005645
2017-04-10 19:17 Isilkor Note Added: 0005646
2017-04-10 19:25 Isilkor Note Edited: 0005646 View Revisions
2017-04-10 19:26 Isilkor Severity block => major
2017-04-10 22:06 Marky File Added: Test1903.ocs.zip
2017-04-10 22:08 Marky Note Added: 0005647
2017-04-11 19:10 Marky Note Added: 0005649
2017-04-11 19:33 Isilkor Note Added: 0005650
2017-04-11 19:39 Marky Note Added: 0005651
2017-04-11 19:41 Isilkor Note Added: 0005652
2017-04-11 20:33 Marky File Added: OpenClonk.log
2017-04-11 20:33 Marky Note Added: 0005653
2017-04-12 11:27 Isilkor Assigned To => Isilkor
2017-04-12 11:27 Isilkor Status new => resolved
2017-04-12 11:27 Isilkor Resolution open => no change required
2017-04-12 11:27 Isilkor Note Added: 0005654
+Issue History